
#import <stdlib.h>
#import <math.h>
#import <string.h>
#import <ctype.h>

#import "RDebug.h"

#import "Model.h"
#import "Pop.h"
#import "Agent.h"
#import "World.h"
#import "Org.h"

@implementation Pop

// standard get/set methods

-(int) getnumAgents { return numAgents; }
-(id) getagents { return agents; }
-(id) getmodel { return model; }
-(id) getorg { return org; }
-(id) getworld { return world; }

-setmodel: (id) o { model = o; return self; }
-setworld: (id) o { world = o; return self; }
-setorg: (id) o { org = o; return self; }

//////////////////////////////////////////////////
// createEnd
// assumes model, etc have been set.
// agents parameter format can be one of:
//  H - hierarchical, ie important agents get 1.0 down to 0.1 (10 agents)
//  E - even, all get 0.55 (10 agents)
//  S - secretaries get 1.0, down to 0.1 (10 agents)
//  1,0.1,2,0.2,...
// ie the detailed rank and then energy/T of each agent.
// Id's are assigned in order.

-createEnd: (id) aZone {
    unsigned int	nextId, rank;
	float			e;
	char			*cp, *stripFloat(), *stripUI();
    id          	agnt;

    agents = [List create: aZone];

	cp = [model getParStringValueFor: "agents"];
	nextId = 1;

	if ( toupper(*cp)=='H'||toupper(*cp)=='E'||toupper(*cp)=='S' ) {
		for ( rank = 1; rank <= 10; ++rank ) {
			agnt = [Agent createBegin: aZone];
			[agnt setId: nextId++];
			[agnt setrank: rank];
			if ( toupper(*cp) == 'H' )
				e = 1.0 - ((rank-1) * 0.1);
			else if ( toupper(*cp) == 'E' )
				e = 0.55;
			else if ( toupper(*cp) == 'S' )
				e = rank * 0.1;
			[agnt setE: (double) e];
			[agnt setpop: self];
			agnt = [agnt createEnd: aZone];
			[agents addLast: agnt];
		}
	} 
	else {
		while ( (cp = stripUI(cp,&rank)) ) {
			if ( (cp = stripFloat(cp,&e)) ) {
				agnt = [Agent createBegin: aZone];
				[agnt setId: nextId++];
				[agnt setrank: rank];
				[agnt setE: (double) e];
				[agnt setpop: self];
				agnt = [agnt createEnd: aZone];
				[agents addLast: agnt];
			}
			else {
				SEMsg("\nERROR (Pop-createEnd): parsing agents failed.\n");
				exit(-1);
			}
		}
	}

	if ( RDebug > 1 ) { // debugging
		id		index, o;
		char	buff[1024];
		SEMsg("--> Agents:\n" );
		index = [agents begin: aZone];
		while ( (o = [index next]) ) {
			[o displayInBuff: buff];
			SEMsg1("%s",buff);
		}
	}

    return self;
}

//////////////////////////////////////////////////////
// asciidisplayAgents
// just for debugging

-(void) asciidisplayAgents: (id) theAgents {
	id				agnt, index;
	int				cnt = 0;
	char			buff[1024];
	extern id		xZone;

    index = [theAgents begin: xZone];
	while ( (agnt = [index next]) ) {
		[agnt displayInBuff: buff];
		SOMsg1( "%s", buff );
		++cnt;
	}
    [index dropFrom: xZone];
	SOMsg1("%d Agents.\n", cnt );
}

@end
